' FFScriptFiles= datenblitz.vbs, datenblitz.ini
' zeigt EXIF- und IPTC-Daten in der Gesamtbildschirmansicht,
' auch GeoBild und Bereichsberschreitung
' Konfiguration ber die Datei datenblitz.ini
' seit V 3.0 Zusammenarbeit mit Datenblitz-Tool 
' ** KGsoft (Andreas Kleingnther) 
' Version 4.4 vom 09.10.2011
' Version 4.5 vom 20.03.2012	Exif: "Rating", "RatingPercent" 
' Version 4.6 vom 26.03.2012	"Seitenverhltnis", "Entfernung", Belichtungszeit formatiert 
' Version 4.7 vom 08.04.2012	Berechnung Seitenverhltnis verbessert (mit Toleranz)
' Version 4.8 vom 13.07.2012	Fehler bei nur einer Datenzeile bzw. Unterdrckung leerer Zeilen behoben
' Version 4.9 vom 20.09.2012	nur nderung im Datenbltztool
' Version 5.0 vom 25.11.2013	Bei Umrechnung Geokoordinaten wird Gebietsschema bercksichtigt (Punkt / Komma) 
' Version 5.1 vom 26.11.2013	automatisches Codepage-Mapping durch FF ab V 3.50 beta 16 wird bercksichtigt 

option explicit
Const SkriptName = "datenblitz.ini"
Dim Bild
Dim Datenfeld_1
Dim Datenfeld_2 ()
Dim i, j
Dim objFs, Kurzbeschreibung, KBvorhanden, LaengeMax
Dim WshShell
Dim Font
Dim Schriftgroesse
Dim Schriftstaerke
Const Trenner =" : "
Dim A, B
Dim Codepage, Fremdcode
Dim ohne_leere_Werte
Dim Wert
Dim Datenfeld_3 ()
Dim DF3_Zaehler
Dim Escape

Dim GeoBild
Dim MapProvider			' Kartenanbieter: GoogleMaps, OSM
Dim VertTextStart
Dim GeoBildHigh			' Gre des quadratischen Kartenbildes in Pixel
GeoBildHigh = 350
Dim BUEB				' Bereichsberschreitung

Bild = FF_GetParam()
Call Main

Sub Main
	if not Version_equal_or_better("3.02.22") then
			FF_DrawText "Es ist mindestens die FF-Version 3.02 build 22 erforderlich.",0,0,Schriftgroesse,0,Schriftstaerke,false,false,font,rgb(240,240,240)
		Exit Sub
	end if
	
	Call DefinitionLesen
	Call DF
	If ohne_leere_Werte = "ja" and DF3_Zaehler > 0 then	' ohne leere Datenzeilen, nur Zeichnen, wenn zumindest eine Datenzeile existent
		Call Zeichnen
	ElseIf ohne_leere_Werte = "nein" Then 
		Call Zeichnen 		
	End If
End Sub

Sub DF
	Datenfeld_1 = Split (Kurzbeschreibung,vbNewLine,-1,1)

	Redim Preserve Datenfeld_2 (1, Ubound(Datenfeld_1) - 1)
	For i = 0 to Ubound(Datenfeld_1) - 1
		if Datenfeld_1(i) <> "" Then							' Leerzeilen abfangen
			Datenfeld_2 (0, i) = Left (Datenfeld_1(i), InStr(Datenfeld_1(i), vbTab)-1)								' Parameter/Daten
			Datenfeld_2 (1, i) = Right (Datenfeld_1(i),Len (Datenfeld_1(i)) - InStrRev(Datenfeld_1(i),"#",-1, 1))	' Beschreibung
		End If
	Next

	'** Zeichenstze
	FF_LoadIPTC(Bild)
	Codepage = ""
	If not Version_equal_or_better("3.50.16") Then 			' ab 3.50 beta 16 erfolgt Mapping automatisch durch FF
		Escape = FF_GetIPTC("Characterset")
		if Len(Escape) <> 0 then
			Fremdcode = 1
			Escape = Right(Escape, 2)				' Escape-Zeichen abschneiden
			Select Case Escape
				Case HxAnsi(25) & HxAnsi(73)		' MacRoman
					Codepage = 10000
				Case HxAnsi(25) & HxAnsi(47)		' UTF-8
					Codepage = 65001
				Case HxAnsi(28) & HxAnsi(42)		' US-ASCII
					Codepage = 20127
				Case HxAnsi("2C") & HxAnsi(41)		' ISO-8859-1
					Codepage = 28591
				Case HxAnsi("2D") & HxAnsi(41)
					Codepage = 28591
				Case HxAnsi("2E") & HxAnsi(41)
					Codepage = 28591	
				Case HxAnsi("2F") & HxAnsi(41)
					Codepage = 28591	
				Case HxAnsi("2C") & HxAnsi(62)		' ISO-8859-15
					Codepage = 28605
				Case HxAnsi("2D") & HxAnsi(62)
					Codepage = 28605
				Case HxAnsi("2E") & HxAnsi(62)
					Codepage = 28605
				Case HxAnsi("2F") & HxAnsi(62)
					Codepage = 28605
				End Select
		end if
	End If	
	'** Werte ermitteln
	DF3_Zaehler = 0
	For i = 0 to Ubound(Datenfeld_2, 2)
		if ohne_leere_Werte = "ja" Then					' leere Datenzeilen werden unterdrckt
			Wert = FF_Parameter (Datenfeld_2 (0, i), Bild)
			if Wert <> "" or Datenfeld_2 (1,i) = "-----" Then
				Redim Preserve Datenfeld_3 (1, DF3_Zaehler)
				Datenfeld_3 (0, DF3_Zaehler) = Wert					' Daten
				Datenfeld_3 (1, DF3_Zaehler) = Datenfeld_2(1, i)	' Beschreibung
				DF3_Zaehler = DF3_Zaehler + 1
			End If
		Else										    ' auch leere Datenzeilen werden angezeigt
			Datenfeld_2 (0,i) = FF_Parameter (Datenfeld_2 (0,i), Bild)
		End If
	Next
	
	if ohne_leere_Werte = "ja" and DF3_Zaehler > 0 then	' leere Datenzeilen werden unterdrckt
		Redim Datenfeld_2 (1, Ubound(Datenfeld_3, 2) )
		for j = 0 to Ubound(Datenfeld_3, 2) 
			Datenfeld_2 (0,j) = Datenfeld_3 (0,j)
			Datenfeld_2 (1,j) = Datenfeld_3 (1,j)
		next
	End If
	
	if Codepage <> "" then						' Zeichensatzmapping
		For i = 0 to Ubound(Datenfeld_2, 2)
				Datenfeld_2 (0,i) = FF_MapCodePage(Datenfeld_2 (0,i), Codepage, 0)
		Next			
	end if
	
End Sub

Sub Zeichnen

	Dim gLD, gLB, gLT			' grte Lnge Daten / Beschreibung	/ Trenner
	Dim laengeText
	Dim relZeile
	Dim HoeheText
	Dim TextHoeheGesamt, TextBreiteGesamt, ZuGross
	Dim sp						' Array der Schlagwrter 
	Dim anz_sp					' Anzahl der Schlagwrter
	Dim sw_array
	Dim zd
	
	If BUEB = "ja" Then
		REM if  FF_CheckKey() = 66 Then
			FF_CreateLimit()		' Anzeige Bereichsberschreitung
		REM End If
	End If
	
	VertTextStart = 0			' vertikaler Startpunkt fr den Text (unter dem Bild)
	If GeoBild = "ja" Then
		Call GeoBildAnzeigen
	End If
	
	' lngste Zeile ermitteln; relevante Zeilen ermitteln
	gLD = 0
	gLB = 0
	relZeile = 0
			
	for i = 0 to Ubound(Datenfeld_2, 2)
		if Datenfeld_2 (1,i) <> "Schlagwrter" then 	' Breite Daten bei Schlagwrtern hier unbeachtlich
			Datenfeld_2 (0,i) = Replace(Datenfeld_2 (0,i), vbNewLine, "; ")		' vbNewLine zu "; " wandeln
			laengeText = FF_GetTextWidth (Datenfeld_2 (0,i), Schriftgroesse, Schriftstaerke, false, false, font)
			if laengeText > gLD then gLD = laengeText
		End If
		' Sonderbehandlung Schlagwrter
		if Datenfeld_2 (1,i) = "Schlagwrter" Then
			sp = split(Datenfeld_2(0,i), vbNewLine)
			anz_sp = ubound(sp)
			for j = 0 to anz_sp							' Bercksichtigung Breite Daten bei Schlagwrtern
				laengeText = FF_GetTextWidth (sp(j), Schriftgroesse, Schriftstaerke, false, false, font)
				if laengeText > gLD then gLD = laengeText
			Next
		End If
	next
	
	' grte Lnge Beschreibung
	for i = 0 to Ubound(Datenfeld_2, 2)
		if Datenfeld_2 (0,i) <> "" then 	' Breite Beschreibung wird nur beachtet, wenn es Daten gibt
			laengeText = FF_GetTextWidth (Datenfeld_2 (1,i), Schriftgroesse, Schriftstaerke, false, false, font)
			if laengeText > gLB then gLB = laengeText
		End If
	next
	gLT = FF_GetTextWidth (Trenner, Schriftgroesse, Schriftstaerke, false, false, font)
	TextBreiteGesamt = gLB + gLT + gLD
	if TextBreiteGesamt > FF_GetSystemMetrics(0) then		' grer als Bildschirmauflsung
		TextBreiteGesamt = FF_GetSystemMetrics(0)		
		ZuGross = 1
	end if
	
	' Hhe des Textblocks
	HoeheText = FF_GetTextHeight (Datenfeld_2 (0,0), Schriftgroesse, Schriftstaerke, false, false, font)
	' Sonderfall Linie in erster Zeile 
	if HoeheText = 0 then HoeheText = FF_GetTextHeight (Datenfeld_2 (1,0), Schriftgroesse, Schriftstaerke, false, false, font)
	If anz_sp > 0 Then
		TextHoeheGesamt = HoeheText * ((Ubound(Datenfeld_2, 2) +  1) + anz_sp)
	Else
		TextHoeheGesamt = HoeheText * ((Ubound(Datenfeld_2, 2) +  1))
	End If
	if TextHoeheGesamt + VertTextStart > FF_GetSystemMetrics(1) then 		' grer als Bildschirmauflsung
		TextHoeheGesamt = FF_GetSystemMetrics(1) - VertTextStart		
		ZuGross = 1
	end if
	
	' Hintergrund' Hintergrund zeichnen
	FF_PushImage()
	FF_NewImage TextBreiteGesamt , TextHoeheGesamt, 0
	FF_MixImage 0, 0 + VertTextStart, TextBreiteGesamt, TextHoeheGesamt, 128
	FF_PopImage()
	
	' Text ausgeben
	zd = 0 + VertTextStart
	for i = 0 to Ubound(Datenfeld_2, 2)
		If Datenfeld_2 (1,i) = "-----" Then			'horizontaler Strich
			FF_HLine 0, gLB + gLT + gLD, zd + Schriftgroesse / 2, rgb(240,240,240)
		Else
			FF_DrawText Datenfeld_2 (1,i),0,zd,Schriftgroesse,0,Schriftstaerke,false,false,font,rgb(240,240,240)
			If Datenfeld_2 (0,i) <> "" Then			'Anfhrungszeichen nur, wenn auch Daten da sind
				FF_DrawText Trenner,gLB,zd,Schriftgroesse,0,Schriftstaerke,false,false,font,rgb(240,240,240)
			End If
			if Datenfeld_2 (1,i) = "Schlagwrter" and anz_sp > 0 Then		' trennen und untereinander wenn mehr als ein Schlagwort
				for j = 0 to anz_sp
					FF_DrawText sp(j),gLB+gLT,zd,Schriftgroesse,0,Schriftstaerke,false,false,font,rgb(240,240,240)
					zd = zd + Schriftgroesse
				Next
				zd = zd - Schriftgroesse				
			Else
				FF_DrawText Datenfeld_2 (0,i),gLB+gLT,zd,Schriftgroesse,0,Schriftstaerke,false,false,font,rgb(240,240,240)
			End If
		End If
		zd = zd + Schriftgroesse
	next
	if ZuGross = 1 then		' Warnung, zu wenig Platz fr die Daten
		FF_TextAlign (2)	' schreibt von rechts nach links
		FF_DrawText "Warnung! Es knnen nicht alle Daten angezeigt werden.", FF_GetSystemMetrics(0), 0,Schriftgroesse,0,Schriftstaerke,true,true,font,rgb(255,0,0)
	end if
End Sub

' Geobild einfgen
Sub GeoBildAnzeigen
	Dim Breite, Laenge
	Dim Koordinaten
	Dim URL
	Dim Rand
	
	FF_LoadExif (Bild)
	Breite = FF_GetExifTag("Latitude")
	Laenge = FF_GetExifTag("Longitude")
	if Breite <> "" Then
		Koordinaten = grad2decimal (Breite) & "," & grad2decimal (Laenge)
		FF_PushImage()						' Original sichern
		
		If MapProvider = "OSM" Then
			' OpenStreetMap - staticMapLite: http://dev.openstreetmap.de/staticmap/ 
			URL= "http://staticmap.openstreetmap.de/staticmap.php?center=" & Koordinaten & "&zoom=16&size=" & GeoBildHigh -2 & "x" & GeoBildHigh + 30 -2 & "&markers=" & Koordinaten &",lightblue1"
		Else
			' GoogelMaps - Static Maps API
			URL = "http://maps.google.com/maps/api/staticmap?&size=" & GeoBildHigh -2 & "x" & GeoBildHigh + 30 -2  & "&maptype=hybrid&markers=color:purple|size:normal|label:A|" & Koordinaten & "|&sensor=false"
		End If
		
		On Error Resume Next
		FF_LoadURL url, FF_GetFFPathEx(2) & "\datenblitztool\geobildtemp.jpg"
		FF_LoadImage FF_GetFFPathEx(2) & "\datenblitztool\geobildtemp.jpg"
		FF_Crop 0, 0, GeoBildHigh -2, GeoBildHigh -2							' Google-Beschriftung unten abschneiden
		if err <> 0 Then
			FF_LoadImage FF_GetFFPathEx(2) & "\datenblitztool\errorbild.jpg"
			GeoBildHigh = 200
		End If
		On Error GoTo 0
		Rand = 1
		FF_ExtendCanvas Rand, Rand, Rand, Rand, 0, 0, 0							' Bild schwarz umranden
		FF_MixImage 0, 0, GeoBildHigh, GeoBildHigh, 256
		FF_PopImage()
		VertTextStart = GeoBildHigh
	End If
End Sub

		Sub DefinitionLesen
	'on error resume next
	Const ForReading = 1
	Dim Skript, Anfang, Ende, Zeile
	
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)
	
	if err.number = 53 then
		msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   	"Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung"
		exit sub
	end if
	
	Do While Skript.AtEndOfStream <> True
		Zeile = Skript.ReadLine
		' Anzeigeparameter
		if instr(Zeile,"Font") > 0 then Font = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		if instr(Zeile,"Schriftgroesse") > 0 then Schriftgroesse = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		if instr(Zeile,"Schriftstaerke") > 0 then Schriftstaerke = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		if instr(Zeile,"ohne_leere_Werte") > 0 then ohne_leere_Werte = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		
		' Geobild
		if instr(Zeile,"GeoBild") > 0 then GeoBild = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		if instr(Zeile,"MapProvider") > 0 then MapProvider = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		
		' Bereichsberschreitung
		if instr(Zeile,"BUEB") > 0 then BUEB = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
		
		if instr(Zeile,"'** Ende Daten-Definition") > 0 then Ende = true
		if Ende then exit do
		
		if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
		if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
		
		if instr(Zeile,"** Start Daten-Definition") > 0 then Anfang = true
	Loop
		
	if Anfang and Ende then KBvorhanden = true
	Skript.Close
End Sub

'**************************************************************
Function FF_Parameter (Parameter, Bild)
'**************************************************************
'Dim X, Y
Dim p1, teil
Dim dt, d
Dim ka, i
Dim Wert
Dim fso, f, bytes
Select Case Parameter
	Case "Pfad_Datei"
		FF_Parameter = Bild
	Case "Pfad"
		FF_Parameter = Left(Bild, InStrRev (Bild,"\", -1, 1))
	Case "Datei"
		FF_Parameter = Right(Bild, (Len(Bild) - InStrRev (Bild,"\", -1, 1)))
	Case "Verzeichnis"
		p1 = InStrRev (Bild,"\", -1, 1)
		teil = left (Bild, p1 -1)
		FF_Parameter = Right(teil, (Len(teil) - InStrRev (teil,"\", -1, 1)))		 
	Case "BreiteHhe"
		FF_Parameter = FF_GetImageFileWidth(Bild) & "x" & FF_GetImageFileHeight(Bild)
	Case "BreiteHheSV"
		A = FF_GetImageFileWidth (Bild)
		B = FF_GetImageFileHeight (Bild)
		FF_Parameter = A & "x" & B
		REM Call Kuerzen (A, B)
		FF_Parameter = FF_Parameter & " (" & Seitenv(A, B) & ")"
	Case "Seitenverhltnis"
		A = FF_GetImageFileWidth (Bild)
		B = FF_GetImageFileHeight (Bild)
		REM Call Kuerzen (A, B)
		FF_Parameter =  Seitenv(A, B) 
	Case "DateiErzeugung"
		FF_Parameter = 	FF_GetFileDate (Bild, 1)
	Case "DateiZugriff"
		FF_Parameter = 	FF_GetFileDate (Bild, 2)
	Case "Dateigre"
		Set fso = CreateObject("Scripting.FileSystemObject")
		set f = fso.GetFile(Bild)
		bytes = f.size
		If bytes < 1024 then FF_Parameter = bytes & " Byte"
		If bytes >= 1024 and bytes < 1048576 Then FF_Parameter = Round(bytes / 1024, 2) & " kB"
		If bytes >= 1048576 then FF_Parameter = Round(bytes / 1048576, 2) & " MB"
End Select

FF_LoadExif (Bild)
IF FF_HasExif() then
	Select Case Parameter
	Case "Altitude"
		FF_Parameter = FF_GetExifTag("Altitude")
	Case "ApertureValue"
		FF_Parameter = FF_GetExifTag("ApertureValue")
	Case "Artist"
		FF_Parameter = FF_GetExifTag("Artist")
	Case "BrightnessValue"
		FF_Parameter = FF_GetExifTag("BrightnessValue")
	Case "Copyright1"
		FF_Parameter = FF_GetExifTag("Copyright1")
	Case "Copyright2"
		FF_Parameter = FF_GetExifTag("Copyright2")
	Case "DateTime"
		FF_Parameter = FF_GetExifTag("DateTime")
	Case "DateTimeDigitized"
		FF_Parameter = FF_GetExifTag("DateTimeDigitized")
	Case "DateTimeOriginal"
		if Instr(FF_GetExifTag("DateTimeOriginal"),":") > 0 then	' gltiger Datums-Eintrag vorhanden
			dt = split (FF_GetExifTag("DateTimeOriginal"))
			d = split(dt(0),":")		
			FF_Parameter = d(2) & "." & d(1) & "." & d(0) & " - " & dt(1)		
		end if
	Case "DateOriginal"
		if Instr(FF_GetExifTag("DateTimeOriginal"),":") > 0 then	' gltiger Datums-Eintrag vorhanden
			dt = split (FF_GetExifTag("DateTimeOriginal"))
			d = split(dt(0),":")
			FF_Parameter = d(2) & "." & d(1) & "." & d(0)
		end if
	Case "ExposureBiasValue"
		Wert = FF_GetExifTag("ExposureBiasValue")
		if GetLocale <> 2055 and GetLocale <>  5127 Then	' nicht Schweiz oder Lichtenstein 
			Wert = Replace (Wert, ".", ",")					' Punkt durch Komma ersetzen, damit Round funktioniert
		End If
		if Len(Wert) > 0 Then
			FF_Parameter = Round(Wert, 2) & " EV"
		End If
	Case "ExposureIndex"
		FF_Parameter = FF_GetExifTag("ExposureIndex")
	Case "ExposureProgram"
		Wert = FF_GetExifTag("ExposureProgram")
		if len(Wert) > 0 Then
			Select Case Wert
			Case 1
				FF_Parameter = "Manuell"
			Case 2
				FF_Parameter = "Programm (P)"
			Case 3
				FF_Parameter = "Zeitautomatik (A)"
			Case 4
				FF_Parameter = "Blendenautomatik (S)"
			Case 5
				FF_Parameter = "Kreativ-Programm"
			Case 6
				FF_Parameter = "Action-Programm"
			Case 7
				FF_Parameter = "Portrait"
			Case 8
				FF_Parameter = "Landschaft"
			Case Else 
				FF_Parameter = "unbekannt (" & Wert & ")"
			End Select
		End If
	Case "ExposureTime"
		 Wert = FF_GetExifTag("ExposureTime")
		 FF_Parameter = BelichtDezBruch (Wert)
	Case "Flash"
		Wert = FF_GetExifTag("Flash")
		if Len (Wert) > 0 Then
			Wert = DezBin8(Wert)
			if Mid(Wert,8,1) = "1" then FF_Parameter = "mit Blitz"
			if Mid(Wert,8,1) = "0" then FF_Parameter = "ohne Blitz"
			if Mid(Wert,4,2) = "01" then FF_Parameter = FF_Parameter  & ", forciert ein"
			if Mid(Wert,4,2) = "10" then FF_Parameter = FF_Parameter  & ", forciert aus"
			if Mid(Wert,4,2) = "11" then FF_Parameter = FF_Parameter  & ", Auto"
			if Mid(Wert,2,1) = "1" then FF_Parameter = FF_Parameter  & ", rote Augen"
		End If
	Case "FNumber"
		FF_Parameter = FF_GetExifTag("FNumber")
	Case "FocalLength"
		FF_Parameter = FF_GetExifTag("FocalLength")
	Case "FocalLengthIn35mmFilm"
		FF_Parameter = FF_GetExifTag("FocalLengthIn35mmFilm")
	Case "ImageDescription"
		FF_Parameter = FF_GetExifTag("ImageDescription")
	Case "ISOSpeedRatings"
		FF_Parameter = FF_GetExifTag("ISOSpeedRatings")
	Case "Latitude"
		FF_Parameter = FF_GetExifTag("Latitude")
	Case "Longitude"
		FF_Parameter = FF_GetExifTag("Longitude")
	Case "LightSource"
		FF_Parameter = FF_GetExifTag("LightSource")
	Case "Make"
		FF_Parameter = FF_GetExifTag("Make")
	Case "MapDatum"
		FF_Parameter = FF_GetExifTag("MapDatum")
	Case "MaxApertureValue"
		FF_Parameter = FF_GetExifTag("MaxApertureValue")
	Case "MeteringMode"
		Wert = FF_GetExifTag("MeteringMode")
		if Len(Wert)>0 Then
			Select Case Wert
			Case 0
				FF_Parameter = "unbekannt"
			Case 1
				FF_Parameter = "Integral"
			Case 2
				FF_Parameter = "Mittenbetont"
			Case 3
				FF_Parameter = "Spot"
			Case 4
				FF_Parameter = "MultiSpot"
			Case 5
				FF_Parameter = "Mehrfeld"
			Case Else 
				FF_Parameter = "unbekannt (" & Wert & ")"
			End Select
		End If
	Case "Model"
		FF_Parameter = FF_GetExifTag("Model")
	Case "Orientation"
		Wert = FF_GetExifTag("Orientation")
		If len(Wert) > 0 Then
			If Wert = "1" then 	
				FF_Parameter = "quer"
			ElseIf Wert = "3" Then	
				FF_Parameter = "quer, Kopflage"
			ElseIf Wert = "6" Then	
				FF_Parameter = "hoch, links gekippt"
			ElseIf Wert = "8" Then	
				FF_Parameter = "hoch, rechts gekippt"
			Else
				FF_Parameter = FF_GetExifTag("Orientation")
			End If
		End If
	Case "ResolutionUnit"
		FF_Parameter = FF_GetExifTag("ResolutionUnit")
	Case "Satellites"
		FF_Parameter = FF_GetExifTag("Satellites")
	Case "ShutterSpeedValue"
		FF_Parameter = FF_GetExifTag("ShutterSpeedValue")
	Case "Software"
		FF_Parameter = FF_GetExifTag("Software")
	Case "SubjectDistance"
		FF_Parameter = FF_GetExifTag("SubjectDistance")
	Case "TimeStamp"
		FF_Parameter = FF_GetExifTag("TimeStamp")
	Case "UserComment"
		FF_Parameter = FF_GetExifTag("UserComment")
	Case "WhiteBalance"
		Wert = FF_GetExifTag("WhiteBalance")
		If len(Wert) > 0 Then		
			if Wert = 1 then FF_Parameter = "manuell"
			if Wert = 0 then FF_Parameter = "automatisch"
		End If
	Case "XResolution"
		FF_Parameter = FF_GetExifTag("XResolution")
	Case "YResolution"
		FF_Parameter = FF_GetExifTag("YResolution")
	Case "ExposureTimeAdvanced"
		Wert = FF_GetExifTagAdvanced("ExposureTime")
		if Len(Wert) > 0 then 
			FF_Parameter = Wert  & " s"
		End If
	Case "FNumberAdvanced"
		FF_Parameter = FF_GetExifTagAdvanced("FNumber") 
	Case "FocalLengthAdvanced"
		Wert = FF_GetExifTagAdvanced("FocalLength")
		if Len(Wert) > 0 Then
			FF_Parameter =  Wert & " mm"
		End If
	Case "LightSourceAdvanced"
		FF_Parameter = FF_GetExifTagAdvanced("LightSource")
	Case "WhiteBalanceAdvanced"
		FF_Parameter = FF_GetExifTagAdvanced("WhiteBalance")
	Case "Rating"
		Wert = FF_GetExifTag("Rating")
		If Wert <> "" Then
			FF_Parameter = String(Wert, "*")
		End If		
	Case "RatingPercent"
		FF_Parameter = FF_GetExifTag("RatingPercent")
	Case "SubjectDistance"
		FF_Parameter = FF_GetExifTag("SubjectDistance")
	End Select
End If

Select Case Parameter
	Case "GEOyesno"
		if Len(FF_GetExifTag("Latitude")) > 0 Then
			FF_Parameter = "ja"
		Else
			FF_Parameter = "nein"
		End If
	Case "UserCommentyesno"
		if Len(FF_GetExifTag("UserComment")) > 0 Then
			FF_Parameter = "ja"
		Else
			FF_Parameter = "nein"
		End If
End Select

' IPTC aus FF 
FF_LoadIPTC(Bild)
IF FF_HasIPTC() then
	Select Case Parameter
	Case "Byline"
		FF_Parameter = FF_GetIPTC("Byline")
	Case "BylineTitle"
		FF_Parameter = FF_GetIPTC("BylineTitle")
	Case "Caption/Abstract"
		FF_Parameter = FF_GetIPTC("Caption/Abstract")
	Case "Characterset"
		Escape = FF_GetIPTC("Characterset")
		if Len(Escape) <> 0 then
			Escape = Right(Escape, 2)				' Escape-Zeichen abschneiden
			Select Case Escape
				Case HxAnsi(25) & HxAnsi(73)		' MacRoman
					FF_Parameter = "Macintosh Roman"
				Case HxAnsi(25) & HxAnsi(47)		' UTF-8
					FF_Parameter = "UTF-8"
				Case HxAnsi(28) & HxAnsi(42)		' US-ASCII
					FF_Parameter = "US-ASCII"
				Case HxAnsi("2C") & HxAnsi(41)		' ISO-8859-1
					FF_Parameter = "ISO-8859-1"
				Case HxAnsi("2C") & HxAnsi(62)		' ISO-8859-15
					FF_Parameter = "ISO-8859-15"
				Case Else							' unbekannte Codepage, Hexwerte
					Wert = Escape
					For i = 1 to Len(Wert)
						FF_Parameter = FF_Parameter &  Hex(Asc(Mid(Wert, i, 1))) & "h "
					next
			End Select	
		End If
	Case "Category"
		FF_Parameter = FF_GetIPTC("Category")
	Case "CountyCode"
		FF_Parameter = FF_GetIPTC("CountyCode")
	Case "City"
		FF_Parameter = FF_GetIPTC("City")
	Case "CopyrightNotice"
		FF_Parameter = FF_GetIPTC("CopyrightNotice")
	Case "Country"
		FF_Parameter = FF_GetIPTC("Country")
	Case "Credit"
		FF_Parameter = FF_GetIPTC("Credit")
	Case "DateCreated"
		FF_Parameter = FF_GetIPTC("DateCreated")
	Case "EditStatus"
		FF_Parameter = FF_GetIPTC("EditStatus")
	Case "Headline"
		FF_Parameter = FF_GetIPTC("Headline")
	Case "Keywords"
		FF_Parameter = FF_GetIPTC("Keywords")
	Case "KeywordsLine"
		FF_Parameter = FF_GetIPTC("Keywords")
	Case "ObjectAttributeRef"
		FF_Parameter = FF_GetIPTC("ObjectAttributeRef")
	Case "ObjectName"
		FF_Parameter = FF_GetIPTC("ObjectName")
	Case "OriginalTransmissionReference"
		FF_Parameter = FF_GetIPTC("OriginalTransmissionReference")
	Case "ProvinceState"
		FF_Parameter = FF_GetIPTC("ProvinceState")
	Case "Source"
		FF_Parameter = FF_GetIPTC("Source")
	Case "SpecialInstructions"
		FF_Parameter = FF_GetIPTC("SpecialInstructions")
	Case "Sublocation"
		FF_Parameter = FF_GetIPTC("Sublocation")
	Case "SubjectRef"
		FF_Parameter = FF_GetIPTC("SubjectRef")
	Case "SupplementalCategory"
		FF_Parameter = FF_GetIPTC("SupplementalCategory")
	Case "TimeCreated"
		FF_Parameter = FF_GetIPTC("TimeCreated")
	Case "Urgency"
		FF_Parameter = FF_GetIPTC("Urgency")
	Case "Writer/Editor"
		FF_Parameter = FF_GetIPTC("Writer/Editor")
	End Select
End If

if Parameter = "Keywordsyesno" Then
	if Len(FF_GetIPTC("Keywords")) > 0 Then
		FF_Parameter = "ja"
	Else
		FF_Parameter = "nein"
	End If
end if
End Function

' **Versionskontrolle
Function version_equal_or_better(p_Vers)
	Dim l_VersNr
	l_VersNr=split(p_Vers,".")
	version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000>=_
     l_VersNr(0)*1000+l_VersNr(1)+l_VersNr(2)/1000)
End Function

' ** Umwandlung Dezimalzahl zu 8-BIT-Binr-String
Function DezBin8(Dez)
	Dim x
	Dez = Abs(Dez)
    Do
        If (Dez And 2 ^ x) Then
            DezBin8 = "1" & DezBin8
        Else
            DezBin8 = "0" & DezBin8
        End If     
        x = x + 1
    Loop Until 2 ^ x > Dez
	' auf 8 Zeichen auffllen
	DezBin8 = String(8 - Len(DezBin8), "0") & DezBin8
End Function

' Ersetzt durch SeitenV
REM ' ** Krzen zweier Zahlen
REM Sub Kuerzen(ByRef A, ByRef B)
	REM Dim Rest, TempA, TempB
	REM If IsNumeric(A) And IsNumeric(B) Then
		REM If A = 0 Or B = 0 Then Exit Sub
 		REM If A <> Int(A) Or B <> Int(B) Then Exit Sub
        REM TempA = Abs(A)
        REM TempB = Abs(B)
		REM Do
        	REM Rest = TempA Mod TempB
        	REM TempA = TempB
        	REM TempB = Rest
		REM Loop While (Rest <> 0)
        REM A = A / TempA
        REM B = B / TempA
		
        REM 'a = a / 10 ^ (int(len(a)-1))
        REM 'b = b / 10 ^ (int(len(b)-1))
    REM End If
REM End Sub

' ** wandelt Hez-Zahl in das korrespondiernede ANSI-Zeichen
Function HxAnsi (strHex)
	HxAnsi = Chr(CLng("&H" & strHex))
End Function


'********************************************
'* grad2decimal wandelt  ' " in dezimal
'********************************************
function grad2decimal(ByVal p_Str)
	dim l_Richtung
	dim l_Pos
	dim l_Wert
	dim Gebietsschema

	if p_Str<>"" then
		Gebietsschema = GetLocale                                   ' Gebietsschema des Systems ermitteln
		if Gebietsschema <> 2055 and Gebietsschema <>  5127 Then    ' nicht Schweiz oder Lichtenstein, weil dort auch der Punkt gilt
			p_Str=replace(p_Str,".",",",1)		                    ' Punkt durch Komma ersetzen,
		End If
		'p_Str=replace(p_Str,".",",",1)
		l_Richtung=left(p_Str,1)
		p_Str=ltrim(right(p_Str,len(p_Str)-1))
		l_Pos=instr(p_Str,"")
		REM msgbox l_Wert
		l_Wert=1.0*(left(p_Str,l_Pos-1))
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"'")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"""")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
		Select Case l_Richtung
			Case "s", "S", "w", "W"
				grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
			case Else
				grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
		End Select
	else
		grad2decimal=""
	end if
end function

Sub Log(Parameter, t1, t2, t3)
	' *********************************************************************************
	' * schreibt bis zu drei Werte t1 bis t3 in die Textdatei ff_testlog.txt
	' * mehrere Werte werden durch Semikolon voneinander getrennt und
	' * in einer Zeile dargestellt,
	' * optional wird eine Zeile mit Datum und Uhrzeit voran gestellt
	' * Parameter wird durch Addition folgender Werte gebildet:
	' * 	0 - vorhandene Datei ergnzen
	' * 	1 - vorhandene Datei lschen
	' * 	2 - Zeitstempel einfgen
	' *********************************************************************************

	Dim fso, tf
	Dim Werte
	Const ForAppending = 8
	Dim Logdatei
	Logdatei = FF_GetFFPathEx(2) & "\ff_testlog.txt"
	
	set fso = CreateObject("Scripting.FileSystemObject")
    	
	if Parameter = 1 or  Parameter = 3 Then			' Datei lschen
		If (fso.FileExists(Logdatei)) Then 	
			fso.DeleteFile(Logdatei)				
		End If
	End If
	if Parameter = 2 or Parameter = 3 Then			 ' mit Zeitstempel
		Werte = "----- " & Date & " - " & Time & " -----" & vbNewLine
	End If
		
	if t1 <> "" then Werte = Werte & t1
	if t2 <> "" then Werte = Werte & "; " & t2
	if t3 <> "" then Werte = Werte & "; " & t3

	If not (fso.FileExists(Logdatei)) Then 	
		Set tf = fso.CreateTextFile(Logdatei, True)
		tf.Close
	End If

	Set tf = fso.OpenTextFile(Logdatei, ForAppending, True)
	tf.WriteLine(Werte)
	tf.Close
	'msgbox werte
End Sub

Function BelichtDezBruch (dez)
	' rechnet dezimale Belichtungszeiten in gemeine Brche, ggf. mit Ganzzahlanteil, um
	' KGsoft 26.03.2012
	Dim zaehler, i, ganzteil
	
	dez = Replace(dez,".",",")		' ggf. Punkt durch Komma ersetzen
	If dez*1 = int(dez) Then
		BelichtDezBruch = int(dez) & " s"
		Exit Function
	End If
	
	If dez > 1 Then
		'ganzteil = left(dez, InStr(dez, ",")-1)
		ganzteil = int(dez)
		dez = dez - ganzteil
	End If
	
	i = 1
	Do 
		i = i * 10
		zaehler = dez * i 
		If zaehler > 0 Then
				Exit Do
		End If
	Loop
	BelichtDezBruch = "1/" & Round(i/zaehler) & " s"       ' Round wegen Perioden
	If ganzteil > 0 Then
		BelichtDezBruch = ganzteil & "  " & BelichtDezBruch
	End If
End Function

Function SeitenV (breite, hoehe)
	' Berechnet das ganzzahlige Verhltnis aus zwei Werten
    ' Ausgabe als String "A : B"
	' Toleranz ergibt kleine Werte trotz gewisser Abweichungen	

     Dim SV, n, E
     const T = .005             ' Toleranz

     breite = int(breite)      ' ganzzahliger Anteil
     hoehe = int(hoehe)        ' ganzzahliger Anteil

     SV = breite / hoehe
  
     ' Schleife bis Ergebnis geradzahlig
     n = 0
     do
          n = n + 1
          E = n * SV
          if abs(E - round(E)) < T then exit do
          if n > 1000 then exit do
     loop
     E = round(E)
     REM If n > 1000 then
		REM Msgbox "Es kann kein Ergebnis ermittelt werden.", vbExclamation, "Hinweis"
     REM Exit Function
     REM End If
 
     SeitenV = E & " : " & n
End Function

